#include "player.h"

#include <stdlib.h>
#include <string.h>

#include "protocol.h"
#include "server.h"
#include "udp.h"

Player players[MAX_PLAYERS];

void free_player(Player* player) {
  free(player->must_send_packets);
  free(player->may_send_packets);

  for (int i = 0; i < player->nb_unacked_packets; i++) {
    uv_timer_stop(&player->unacked_packets[i].timer);
    free(player->unacked_packets[i].buffer.base);
  }

  memset(player, 0, sizeof(Player));
}

void kick_player(Player* player, bool is_timeout) {
  if (is_timeout) {
    printf("%s (%hd) left the server (timed out).\n", player->username,
           player->id);
  } else {
    printf("%s (%hd) left the server.\n", player->username, player->id);
  }

  remove_player_from_scene(player);

  INIT_PACKET(S_PACKET_DISCONNECT);
  WRITE_SHORT(player->id);
  WRITE_STRING(player->username);
  WRITE_BOOL(is_timeout);
  IMPORTANT_SERVER_BROADCAST(player);

  free_player(player);
}
