#pragma once
#include <stdbool.h>

extern uv_udp_t* hollowknight_server;

void broadcast_packet(Player* source_player, char* packet, int len,
                      bool same_scene_only, bool is_important);
void send_packet_to_player(Player* player, char* data, int len,
                           bool is_important);
void process_tick(uv_timer_t* handle);
void udp_read(uv_udp_t* req, ssize_t nread, const uv_buf_t* buf,
              const struct sockaddr* addr, unsigned flags);

#define PACKET_SEND(player) \
  send_packet_to_player(player, packet, out_pos, false)
#define SCENE_BROADCAST(player) \
  broadcast_packet(player, packet, out_pos, true, false)
#define SERVER_BROADCAST(player) \
  broadcast_packet(player, packet, out_pos, false, false)
#define IMPORTANT_PACKET_SEND(player) \
  send_packet_to_player(player, packet, out_pos, true)
#define IMPORTANT_SCENE_BROADCAST(player) \
  broadcast_packet(player, packet, out_pos, true, true)
#define IMPORTANT_SERVER_BROADCAST(player) \
  broadcast_packet(player, packet, out_pos, false, true)
